<html>
<head>
<title>OgreRectangle.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRectangle.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRectangle_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Rectangle_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Rectangle_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 
<a name="l00042"></a><a class="code" href="structOgre_1_1Rectangle.html">00042</a>     <span class="keyword">struct </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="structOgre_1_1Rectangle.html">Rectangle</a>
<a name="l00043"></a>00043     {
<a name="l00044"></a><a class="code" href="structOgre_1_1Rectangle.html#a4851de00a37259650c67b9d000ed80d1">00044</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1Rectangle.html#a4851de00a37259650c67b9d000ed80d1">left</a>;
<a name="l00045"></a><a class="code" href="structOgre_1_1Rectangle.html#afb3100f7a6979bfcb45e25ca4b36df2c">00045</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1Rectangle.html#afb3100f7a6979bfcb45e25ca4b36df2c">top</a>;
<a name="l00046"></a><a class="code" href="structOgre_1_1Rectangle.html#ae8be8a35b84e0a60b706df4e4aa9d006">00046</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1Rectangle.html#ae8be8a35b84e0a60b706df4e4aa9d006">right</a>;
<a name="l00047"></a><a class="code" href="structOgre_1_1Rectangle.html#a4f8176ad0efb40889b96c05bfbf61176">00047</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1Rectangle.html#a4f8176ad0efb40889b96c05bfbf61176">bottom</a>;
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="structOgre_1_1Rectangle.html#a248f253e65b63f573bbe368b523567bd">00049</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1Rectangle.html#a248f253e65b63f573bbe368b523567bd">inside</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> x &gt;= left &amp;&amp; x &lt;= right &amp;&amp; y &gt;= top &amp;&amp; y &lt;= bottom; }
<a name="l00050"></a>00050     };
<a name="l00051"></a>00051 
<a name="l00061"></a><a class="code" href="group__General.html#ga81496e2975b6d4654e62db86086bb5a1">00061</a>     <span class="keyword">inline</span> <a class="code" href="structOgre_1_1Rectangle.html">Rectangle</a> <a class="code" href="group__General.html#ga81496e2975b6d4654e62db86086bb5a1" title="Geometric intersection of two rectanglar regions.">intersect</a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Rectangle.html">Rectangle</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Rectangle.html">Rectangle</a>&amp; rhs)
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063         <a class="code" href="structOgre_1_1Rectangle.html">Rectangle</a> r;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065         r.<a class="code" href="structOgre_1_1Rectangle.html#a4851de00a37259650c67b9d000ed80d1">left</a>   = lhs.<a class="code" href="structOgre_1_1Rectangle.html#a4851de00a37259650c67b9d000ed80d1">left</a>   &gt; rhs.<a class="code" href="structOgre_1_1Rectangle.html#a4851de00a37259650c67b9d000ed80d1">left</a>   ? lhs.<a class="code" href="structOgre_1_1Rectangle.html#a4851de00a37259650c67b9d000ed80d1">left</a>   : rhs.<a class="code" href="structOgre_1_1Rectangle.html#a4851de00a37259650c67b9d000ed80d1">left</a>;
<a name="l00066"></a>00066         r.<a class="code" href="structOgre_1_1Rectangle.html#afb3100f7a6979bfcb45e25ca4b36df2c">top</a>    = lhs.<a class="code" href="structOgre_1_1Rectangle.html#afb3100f7a6979bfcb45e25ca4b36df2c">top</a>    &gt; rhs.<a class="code" href="structOgre_1_1Rectangle.html#afb3100f7a6979bfcb45e25ca4b36df2c">top</a>    ? lhs.<a class="code" href="structOgre_1_1Rectangle.html#afb3100f7a6979bfcb45e25ca4b36df2c">top</a>    : rhs.<a class="code" href="structOgre_1_1Rectangle.html#afb3100f7a6979bfcb45e25ca4b36df2c">top</a>;
<a name="l00067"></a>00067         r.<a class="code" href="structOgre_1_1Rectangle.html#ae8be8a35b84e0a60b706df4e4aa9d006">right</a>  = lhs.<a class="code" href="structOgre_1_1Rectangle.html#ae8be8a35b84e0a60b706df4e4aa9d006">right</a>  &lt; rhs.<a class="code" href="structOgre_1_1Rectangle.html#ae8be8a35b84e0a60b706df4e4aa9d006">right</a>  ? lhs.<a class="code" href="structOgre_1_1Rectangle.html#ae8be8a35b84e0a60b706df4e4aa9d006">right</a>  : rhs.<a class="code" href="structOgre_1_1Rectangle.html#ae8be8a35b84e0a60b706df4e4aa9d006">right</a>;
<a name="l00068"></a>00068         r.<a class="code" href="structOgre_1_1Rectangle.html#a4f8176ad0efb40889b96c05bfbf61176">bottom</a> = lhs.<a class="code" href="structOgre_1_1Rectangle.html#a4f8176ad0efb40889b96c05bfbf61176">bottom</a> &lt; rhs.<a class="code" href="structOgre_1_1Rectangle.html#a4f8176ad0efb40889b96c05bfbf61176">bottom</a> ? lhs.<a class="code" href="structOgre_1_1Rectangle.html#a4f8176ad0efb40889b96c05bfbf61176">bottom</a> : rhs.<a class="code" href="structOgre_1_1Rectangle.html#a4f8176ad0efb40889b96c05bfbf61176">bottom</a>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070         <span class="keywordflow">return</span> r;
<a name="l00071"></a>00071     }
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="preprocessor">#endif // _Rectangle_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
